﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.WebUI.UltraWebGrid;
using Infragistics.Web.UI.GridControls;

public partial class WDG_Update : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["Data"] == null)
        {
            WebDataGrid1.DataSource = MakeTable();
            Session["Data"] = MakeTable();
        }
        else {
            WebDataGrid1.DataSource = Session["Data"];
        }

        WebDataGrid1.DataBind();
    }
    private DataTable MakeTable()
    {
        DataTable table = new DataTable("MaterialType");
        DataColumn column;
        DataRow row;

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "RowNum";
        column.ReadOnly = true;
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "DisplayValue";
        column.AutoIncrement = false;
        column.Caption = "DisplayValue";
        column.ReadOnly = false;
        column.Unique = false;
        table.Columns.Add(column);

        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["RowNum"];
        table.PrimaryKey = PrimaryKeyColumns;

        for (int i = 0; i <= 20; i++)
        {
            row = table.NewRow();
            row["RowNum"] = i;
            row["DisplayValue"] = "DisplayValue " + i;
            table.Rows.Add(row);
        }
        return table;
    }

    protected void WebDataGrid1_RowUpdating(object sender, Infragistics.Web.UI.GridControls.RowUpdatingEventArgs e)
    {
        object[] dataKey = e.Row.DataKey;

        DataTable table = (DataTable)Session["Data"];
        if (null != dataKey)
        {
            // First we locate the row in the DataTable object with the corresponding key.
            // If primary key field is editable, must use old row's key to find the row.
            DataRow dr = table.Rows.Find( dataKey );

            try
            {
                if (null != dr)
                {
                    // The update code is similar to that used inside of the Add case.

                    for (int i = 0; i < e.Row.Items.Count; i++)
                    {
                        GridRecordItem c = e.Row.Items[i];

                        // this check is because we have unbound columns
                        // in the grid which have no datasource representation
                        if (-1 != table.Columns.IndexOf(c.Column.Key))
                            if (!dr[c.Column.Key].Equals(c.Value))
                                dr[c.Column.Key] = c.Value;
                    }
                }
            }
            catch (Exception ex)
            {           
                this.WebDataGrid1.DataSource = table;        
            }

            // Normally you would not allow modification of the value
            // that is used to populate your DataKey as this most
            // often corresponds to your primary key.  However, should you allow 
            // for the field that is used for the DataKey, you should
            // update this value.
            Session["Data"] = table;
            e.Row.DataKey[0] = e.Row.Items[0].Value;
        }       

    }
}